#include < amxmodx >
#include < amxmisc >
#include < orpheu >
#include < orpheu_memory >

new const PLUGIN_VERSION[ ] = "1.0";
new const FILE_NAME[ 8 ] = "AFR.ini";
new const REGEX_DIR[ 12 ] = "advreplacer";
new const STANDARD_FILL[ 64 ] = "^"common/wpn_denyselect.wav^" ^"common/bodysplat.wav^" ^"s^"";

new PATH_FILE[ 64 ];
new REGEX_FILE_DIR[ 64 ];
new FULL_DIR[ 64 ];

public plugin_precache( ) {
	get_configsdir( PATH_FILE, charsmax( PATH_FILE ) );
	
	format( FULL_DIR, charsmax( FULL_DIR ), "%s/%s/%s", PATH_FILE, REGEX_DIR, FILE_NAME );
	format( REGEX_FILE_DIR, charsmax( REGEX_FILE_DIR ), "%s/%s", PATH_FILE, REGEX_DIR );
	
	if( dir_exists( REGEX_FILE_DIR ) != 1 )
	{
		mkdir( REGEX_FILE_DIR );
	}
	
	if( file_exists( FULL_DIR ) != 1 )
	{
		write_file( FULL_DIR, STANDARD_FILL, -1 );
	}
	
	new Text[ 255 ], Buffer[ 2 ][ 34 ], Param[ 4 ], iLineLen;
	for( new i = 0; read_file( FULL_DIR, i, Text, charsmax( Text ), iLineLen ); i++ ) {
		if( ( Text[ 0 ] == ';' ) || !iLineLen ) continue;
		
		parse( Text, Buffer[ 0 ], 33, Buffer[ 1 ], 33, Param, 3 );
		
		replace_all( Buffer[ 0 ], 33, "^"", "" );
		replace_all( Buffer[ 1 ], 33, "^"", "" );
		replace_all( Param, 3, "^"", "" );
		
		OrpheuMemoryReplace( "modString", 0, Buffer[ 0 ], Buffer[ 1 ] );
		
		switch( Param[ 0 ] ) {
			case 's':
			{
				precache_sound( Buffer[ 1 ] );
			}
			case 'm':
			{
				precache_model( Buffer[ 1 ] );
			}
			case 'e':
			{
				precache_generic( Buffer[ 1 ] );
			}
		}
	}
}

public plugin_init( ) {
	register_plugin( "Advanced File Replacer", PLUGIN_VERSION, "Ortega" );
	
}
